/*
Speed

Jogo desenvolvido para a matéria PCS 2290,
Fundamentos de Computação II, coordenada pelos professores
Romero Tori e Ricardo Nakamura

Eric Endo, nº 6451071
Design FAUUSP
Turma 03 . 2009
*/


//-----declaração das variáveis-----

//-----parede-----
int wall_px; // posição horizontal
int wall1_py; // posição vertical
int wall2_py; // posição vertical
int wall_v; // velocidade de movimentação
color wall_color; // cor da parede
float randomP; // variável de auxílio para sorteio de posição
float randomC; // variável de auxílio para sorteio de cor

//-----Speed (personagem)-----
int ball_px; // posição horizontal do corpo
int ball_py; // posição vertical do corpo
int foot1_px; // posição horizontal do pé
int foot1_py; // posição vertical do pé
int foot2_px; // posição horizontal do pé
int foot2_py; // posição vertical do pé
int arm1_px; // posição horizontal do braço
int arm1_py; // posição vertical do braço
int arm2_px; // posição horizontal do braço
int arm2_py; // posição vertical do braço
int ball_mov; // velocidade de movimentação do corpo
int foot1_mov; // velocidade de movimentação dos pés
int foot2_mov;
int arm1_mov; // velocidade de movimentação dos braços
int arm2_mov;
color ball_color; // cor do Speed

//-----cores-----
color magenta = #EC008C;
color cyan = #27AAE1;
color yellow = #F9ED32;
color white = #FFFFFF;

//-----background-----
int bg_v; // velocidade de movimentação do background
int[] x; // vetor de posição horizontal
int[] y; // vetor de posição vertical

//-----pontuação e nível-----
int score;
int level;


//-----booleans-----

 // auxíliares para movimentação
boolean keyUP;
boolean keyDOWN;

//"telas" do jogo
boolean start; // tela inicial
boolean game; // jogo
boolean end; // Speed caindo
boolean over; // tela de game over
boolean how; // como jogar

//-----fonte-----
PFont font;

//-----imagens-----
PImage title; //tela inicial
PImage game_over; //tela final


//-----funções-----

//-----desenha a tela inicial-----
void start_game() {
  
  image (title, 0, 0, width, height); // fundo
  
  textAlign(RIGHT);
  
  //botões de level
  fill (cyan); //cor
  rect (535, 105, 15, 15); // posições
  rect (535, 125, 15, 15);
  rect (535, 145, 15, 15);
  text ("slow", 530, 118); //legendas
  text ("fast", 530, 138);
  text ("speed of light", 530, 158);
  
  // botão "como jogar"
  fill (yellow); //cor
  rect (535, 175, 15, 15); //posição
  text ("how to play", 530, 188); //legenda
  
  // efeitos "mouse hover" e detecção de clique
  if (mouseX > 535 && mouseX < 550) {
    
    /*
    Quando o mouse estiver posicionado em cima do botão, um rect de cor
    diferente é desenhado para cobrir o mesmo (efeito mouse hover).
    Na detecção do clique, o programa define os valores das variáveis de
    velocidade de movimentação, e logo em seguida começa o jogo
    (trocando os valores das booleans).
    */
    if (mouseY > 105 && mouseY < 120) { //detecta posição
      fill (255);
      rect (535, 105, 15, 15);
      if (mousePressed) { //detecta clique
        wall_v = 3;
        bg_v = 6;
        start = false; //sai da tela do menu
        game = true; //entra na tela de jogo
      }
    }
    
    else if (mouseY > 125 && mouseY < 140) {
      fill (255);
      rect (535, 125, 15, 15);
      if (mousePressed) {
        wall_v = 6;
        bg_v = 12;
        start = false;
        game = true;
      }
    }
    
    else if (mouseY > 145 && mouseY < 160) {
      fill (255);
      rect (535, 145, 15, 15);
      if (mousePressed) {
        wall_v = 10;
        bg_v = 20;
        start = false;
        game = true;
      }
    }
    
    /*
    no botão de como jogar não há a definição das velocidades,
    pois as mesmas não serão utilizadas
    */
    else if (mouseY > 175 && mouseY < 190) {
      fill (255);
      rect (535, 175, 15, 15);
      if (mousePressed) {
        start = false;
        how = true; //vai para a tela de instruções
      }
    }
    
  }
  
}


//-----efeito de rastro-----
void blur_bg(){
  /*
  um retangulo do tamanho da tela é desenhado a cada draw, porém,
  por ser um retângulo semi-transparente, ele não apaga a tela
  anterior por completo, dando um efeito de rastro ao jogo
  */
  fill (0, 40); //preenchimento preto com transparência
  rect (0, 0, width, height);
}


//-----movimenta o background-----
void move_bg(){
  /*
  utilizando vetores, são criadas aqui 40 particulas que se movem no
  fundo do jogo, em posições aleatórias.
  */
  for (int i = 0; i < 50; i++) {
    fill (random(200, 255), 30); //preenchimento de tom branco (aleatório) e transparente
    ellipse(x[i], y[i], 10, 3); //desenha a particula
    x[i] -= bg_v; //incrementa x[i], movimentando as particulas
    if (x[i] <= 0) { //se a particula atinge o fim da tela (<= 0)
      x[i] = width; //ela volta para o começo
      y[i] = (int)random(height); //em uma posição vertical aleatória
    }
  }
}


//-----sorteia a posição das paredes-----
void choose_wallPosition(){
  
  /*
  a parede no jogo é formada na verdade por dois retangulos.
  pelo posicionamento deles, definimos onde fica o buraco por
  onde Speed deve passar.
  */
  
  randomP = random(3); // atribui um valor de 0 a 3 para a variável randomP
  
  if (randomP <= 1) { // se o valor for de 0 a 1, o buraco fica em cima
    wall1_py = -130;
    wall2_py = 50;
  } else if (randomP > 1 && randomP <= 2) { // de 1 a 2 no meio
    wall1_py = -65;
    wall2_py = 115;
  } else if (randomP > 2) { // e de 2 a 3 em baixo
    wall1_py = 0;
    wall2_py = 180;
  }
}


//-----sorteia a cor da parede-----
color choose_wallColor(){
  
  randomC = random(4); // atribui um valor de 0 a 3 para a variável randomC
  
  if (randomC <= 1) { // se for menor que 1 a parede é branca
    wall_color = white;
  } else if (randomC > 1 && randomC <= 2) { // entre 1 e 2, ciano
    wall_color = cyan;
  } else if (randomC > 2 && randomC <= 3) { // entre 2 e 3, magenta
    wall_color = magenta;
  } else if (randomC > 3) { // entre 3 e 4, amarela
    wall_color = yellow;
  }
  
  return wall_color; //retorna a variável wall_color com a cor sorteada
  
}


//-----movimenta a parede-----
void move_wall(){
  
  if (wall_px <= 0) { //se a parede chega ao final da tela (<= 0)
    choose_wallPosition(); //a posição do buraco é sorteada
    choose_wallColor(); //a sua cor é sorteada
    wall_px = width; //e ela volta para o início da tela
  }
  
  wall_px -= wall_v; //incrementa a posição horizontal, movimentando a parede
  
}


//-----desenha a parede-----
void draw_wall() {
  fill(wall_color); //cor da parede
  rect (wall_px, wall1_py, 5, 150); //posição do retangulo superior
  rect (wall_px, wall2_py, 5, 150); //posição do retangulo inferior
}


//-----movimenta os membros do Speed-----
void move_feet(){
  
  foot1_px += foot1_mov; //incrementa a posição dos membros
  foot2_px += foot2_mov;
  arm1_px += arm1_mov;
  arm2_px += arm2_mov;
  
  if (foot1_px < 30 || foot1_px > 50) { //ao atingir os limites estabelecidos
    foot1_mov = -foot1_mov; //o movimento dos membros se invertem
    foot2_mov = -foot2_mov;
    arm1_mov = -arm1_mov;
    arm2_mov = -arm2_mov;
  }
  
}


//-----movimenta o Speed-----
void move_ball(){
  
  if (keyUP == true) { //se a seta para cima estiver pressionada
    ball_mov = -10; //o incremento vertical é negativo (para cima)
  } else if (keyDOWN == true) { //se for a seta para baixo
    ball_mov = 10; //o incremento é positivo (para baixo)
  }
  
  if (keyUP == false && keyDOWN == false) { //se nenhum dos dois estiver pressionado
    if (ball_py > 110) { //e Speed estiver abaixo do meio
      ball_mov = -10; // ele vai pra cima
    } else if (110 >= ball_py && ball_py >= 100) { //ao chegar perto do meio
      //ele vai para o meio e para. esse if serve para evitar bugs de posição
      ball_mov = 0;
      ball_py = 100;
      foot1_py = 97;
      foot2_py = 103;
      arm1_py = 90;
      arm2_py = 110;
    } else if (ball_py < 90) { //mesma coisa, porém com Speed acima do meio
      ball_mov = 10;
    } else if (90 <= ball_py && ball_py <= 100) {
      ball_mov = 0;
      ball_py = 100;
      foot1_py = 97;
      foot2_py = 103;
      arm1_py = 90;
      arm2_py = 110;
    }
  }
  
  //movimenta Speed inteiro incrementando posição do corpo e membros
  ball_py += ball_mov;
  foot1_py += ball_mov;
  foot2_py += ball_mov;
  arm1_py += ball_mov;
  arm2_py += ball_mov;
  
  /*
  esses ifs evitam que Speed saia da tela, estabelecendo um
  limite de até onde ele pode ir e segurando ele nesse limite
  (mesmo com a tecla pressionada)
  */
  if (ball_py < 35) { //se passar do limite
    ball_py = 35; //ele volta, e assim nunca o ultrapassa
    foot1_py = 32;
    foot2_py = 38;
    arm1_py = 25;
    arm2_py = 45;
  } else if (ball_py > 165) {
    ball_py = 165;
    foot1_py = 163;
    foot2_py = 168;
    arm1_py = 155;
    arm2_py = 175;
  }
  
}


//-----desenha Speed----- 
void draw_ball() {
  
  fill(ball_color); //cor de Speed
  
  //desenha as 5 elipses que formam Speed
  ellipse (ball_px, ball_py, 20, 20);
  ellipse (foot1_px, foot1_py, 20, 5);
  ellipse (foot2_px, foot2_py, 20, 5);
  ellipse (arm1_px, arm1_py, 5, 5);
  ellipse (arm2_px, arm2_py, 5, 5);
  
}


//-----detecta colisão----- 
void collide() {
  
  /*
  resumindo as condições para um impacto:
  a posição horizontal do Speed é a mesma da parede
  E
  ele não esta no "buraco" OU está com uma cor diferente da parede
  */
  if (wall_px > (ball_px - 10) && wall_px < (ball_px + 10) && (ball_py < (wall2_py-20) || ball_py > (wall2_py-10) || wall_color != ball_color)) {
    game = false; // para animação normal do jogo
    end = true; // começa animação de queda do personagem
    //diminui todas as velocidades, o que dará um efeito de câmera lenta (dramático!)
    wall_v = 1;
    ball_mov = 1;
    bg_v = 2;
    //e posiciona os membros de Speed de forma diferente, como se ele estivesse caindo
    foot1_px = ball_px - 15;
    foot2_px = ball_px - 15;
    arm1_px = ball_px - 3;
    arm2_px = ball_px - 3;
  }
}


//-----mostra o controle de cores-----
void show_controls() {
  
  textAlign(CENTER);
  
  /*
  são desenhados quatro quadrados com as cores possíveis de serem atribuídas
  ao Speed, com as letras correspondentes dentro deles
  */  
  fill (yellow);
  rect (570, 10, 20, 20);
  fill (magenta);
  rect (540, 10, 20, 20);
  fill (cyan);
  rect (510, 10, 20, 20);
  fill (white);
  rect (480, 10, 20, 20);
  fill (0);
  text ('f', 580, 27);
  text ('d', 550, 27);
  text ('s', 520, 27);
  text ('a', 490, 27);
}


//-----mostra e atualiza a pontuação-----
void print_score() {
  
  if (wall_px <= 0) { //se a parede chegou ao final da tela (o que significa que Speed passou)
    score += 100; //aumenta a pontuação
  }
  
  textAlign(RIGHT);
  fill (white);
  text (score, 590, 50); //imprime a pontuação
}


//-----mostra e atualiza o nível-----
void print_level() {
  
  /*
  o nível aumenta a cada 1000 pontos.
  sempre que a pontuação aumenta, é verificado se a pontuação dividida por 1000 é igual ao nível
  (o floor serve pra arredondar o resultado SEMPRE para baixo (3.9 = 3))
  caso seja igual, o nível aumenta
  */
  if (wall_px <= 0 && floor(score/1000) == level) { //e se o nível aumenta
    level += 1;
    wall_v += 1; //as paredes se movem mais rápido
    bg_v += 2; //(e o background também para acompanhar a animação)
  }
  
  textAlign(RIGHT);
  fill (white);
  text ("level " + level, 590, 70); //imprime o nível
  
}


//-----animação do Speed caindo-----
void falling(){
  
  //movimenta o Speed pra frente
  ball_px += ball_mov;
  foot1_px += ball_mov;
  foot2_px += ball_mov;
  arm1_px += ball_mov;
  arm2_px += ball_mov;
  
  if (ball_px > 150) { //quando Speed chega em determinado ponto da tela
    end = false; //sai da tela de jogo
    over = true; //e entra na tela de "game over"
  }
  
}


//-----tela de fim de jogo-----
void restart(){
  
  //o desenho de fundo da tela de game over depende da cor que o Speed morreu
  if (ball_color == white) { //se morreu branco
    game_over = loadImage("over_white.png"); //a imagem com ele branco é carregada na variável game_over
    image (game_over, 0, 0, width, height); //e ele aprece branco
  } else if (ball_color == cyan) { //e assim por diante...
    game_over = loadImage("over_cyan.png");
    image (game_over, 0, 0, width, height);
  } else if (ball_color == magenta) {
    game_over = loadImage("over_magenta.png");
    image (game_over, 0, 0, width, height);
  } else if (ball_color == yellow) {
    game_over = loadImage("over_yellow.png");
    image (game_over, 0, 0, width, height);
  }
  
  textAlign(RIGHT);
  
  fill (yellow);
  text ("You've reached level " + level + ", " + score + " points", 550, 150); //mostra o nível e a pontuação final
  
  //desenha o botão de restart
  fill (white);
  rect (535, 165, 15, 15);
  text ("restart", 530, 178);
  
  //efeito mouse hover e detecção de clique, como no início
  if (mouseX > 535 && mouseX < 550) {
    
    if (mouseY > 165 && mouseY < 180) {
      fill (100);
      rect (535, 165, 15, 15);
      if (mousePressed) {
        setup(); //se o clique é detectado, o setup é rodado, restartando todos os valores e voltando à tela inicial
      }
    }
    
  }
  
}


//-----tela de como jogar-----
void how_to_play() {
  
  background(0); //apaga a tela
  show_controls(); //deixa os controles a mostra, como no jogo
  
  fill (white);
  
  //imprime na tela todos os textos com as instruções de jogo
  textAlign(RIGHT);
  text ("Press UP or DOWN to move Speed and a, s, d or f to change colors.", 550, 60);
  text ("You just need to be in the right place with the right color.", 550, 90);
  text ("Enjoy!", 550, 130);
  
  //desenha o botão "voltar ao jogo"
  rect (535, 165, 15, 15);
  text ("play game", 530, 178);
  
  //detecta posição do mouse e faz efeito mouse hover
  if (mouseX > 535 && mouseX < 550) {
    
    if (mouseY > 165 && mouseY < 180) {
      fill (100);
      rect (535, 165, 15, 15);
      if (mousePressed) { //se o clique é detectado
        setup(); //volta para a tela inicial
      }
    }
    
  }
}


//-----setup-----
void setup() {
  
  size(600, 200); //tamanho da tela
 
  wall_px = width; //define a posição inicial da parede como o começo da tela
  wall_v = 0; //com velocidade 0 (a definir, dependendo do nível)
  choose_wallPosition (); //e faz o primeiro sorteio de posição
  choose_wallColor (); //e de cor também
  
  //estabelece posição e cores iniciais do Speed
  ball_px = 40;
  ball_py = 100;
  ball_color = white; //branco é a cor default
  foot1_px = 40;
  foot1_py = 97;
  foot2_px = 40;
  foot2_py = 103;
  arm1_px = 40;
  arm1_py = 90;
  arm2_px = 40;
  arm2_py = 110;
  ball_mov = 0;
  foot1_mov = 1;
  foot2_mov = -1;
  arm1_mov = -1;
  arm2_mov = 1;
  
  //pontuação e nível "zerados"
  score = 0;
  level = 1;
  
  //começa com as booleans de teclas como false (não pressionadas)
  keyUP = false;
  keyDOWN = false;
  
  start = true; //apenas a tela inicial é true (óbvio)
  game = false;
  end = false;
  over = false;
  how = false;
  
  font = loadFont("BlurMedium18.vlw"); //carrega a fonte para a variável font
  textFont(font, 18); // define a fonte de texto
  
  title = loadImage("title.png"); // carrega imagem na variável title
  
  x = new int[50]; //cria os vetores de posição das partículas do background
  y = new int[50];
  //atribui valores aleatórios para as posições criadas
  for (int i = 0; i < 50; i++) {
    x[i] = (int)random(width);
    y[i] = (int)random(height);
  }
  
  noStroke();
  smooth();
  
}


//-----draw-----
void draw() {
  
  if (start == true) { //se o jogo está na tela inicial...
    
    start_game(); //só o start_game() é rodado
    
  } else if (game == true) { //na tela de jogo...
    
    move_bg(); //o background se movimenta
    blur_bg(); //o efeito de rastro é aplicado
    
    move_wall(); //as paredes se movimentam
    draw_wall(); //e são desenhadas
    
    move_feet(); //os membros se movimentam
    move_ball(); //os controles de movimento são obedecidos
    draw_ball(); //e o Speed é desenhado
    
    collide(); //a colisão sempre é verificada
    
    print_score(); //a pontuação é mostrada
    print_level(); //o nível
    show_controls(); //e os controles também
    
    //println (wall_v); //para correção de um problema
  
  } else if (end == true) { //na animação de colisão...
  
    move_bg(); //o background ainda se movimenta
    blur_bg(); //o blur é aplicado
    move_wall(); //a parede se movimenta
    draw_wall(); //e é desenhada
    draw_ball(); //Speed é desenhado
    falling(); //e a movimentação dele é diferente
  
  } else if (over == true) { //na tela de fim de jogo...
    
    restart(); //só o restart() é rodado
    
  } else if (how == true) { //na tela de como jogar...
    
    how_to_play(); //só o how_to_play() é rodado
    
  }
  
}


//-----funções de tecla-----

void keyPressed() {   //roda sempre que uma tecla é pressionada

  if (key == CODED) { // se a tecla é codificada (setas por exemplo)
    
    switch(keyCode) {
      
      case UP: //e é seta para cima
        keyUP = true; //keyUP vira verdadeiro
        break; //e o break possibilita pressionarmos várias teclas ao mesmo tempo
        
      case DOWN: //se é seta para baixo
        keyDOWN = true; //keyDOWN vira verdadeiro
        break;
    
    }
  
  }
  
  switch(key) //se a tecla é "normal"
    {
      case 'a': //ao pressionar a letra a (por exemplo)
        ball_color = white; //o programa atribui à variável ball_color a cor correspondente
        break;
      case 's':
        ball_color = cyan;
        break;
      case 'd':
        ball_color = magenta;
        break;
      case 'f':
        ball_color = yellow;
        break;
      /*
      o código é repetido também com as letras maiúsculas para que ele
      continue funcionando mesmo com o caps lock acionado
      */
      case 'A':
        ball_color = white;
        break;
      case 'S':
        ball_color = cyan;
        break;
      case 'D':
        ball_color = magenta;
        break;
      case 'F':
        ball_color = yellow;
        break;
    }
}

void keyReleased() { // roda sempre que uma tecla é "liberada"

  if (key == CODED) {

    switch(keyCode) {

      case UP: //ao soltar a tecla para cima
        keyUP = false; //o keyUP vira falso
        break;

      case DOWN: //e para baixo acontece a mesma coisa
        keyDOWN = false;
        break;
        
    }
    
  }
  
}

/*
Por que utilizar booleans keyUP e keyDOWN ao invés de atribuir os valores direto à variável?
Porque, sem booleans, o programa ficava com um bug. Ao pressionar mais de uma tecla ao mesmo tempo
(independente da tecla), quando uma delas fosse liberada, ela fazia com que o movimento de
Speed voltasse (o tal bug)... não consegui achar uma lógica para isso, mas as booleans resolveram.
*/
